*-----------------------------------------------------------
* Program    : Tower of Hanoi v1.1
* Written by : Anthony J Bonkoski
* Date       : 4/13/10
* Description: Visual Simulator w/ move counter
*-----------------------------------------------------------
	ORG	$1000

PEG1_X1	EQU	120
PEG1_X2 EQU	125
PEG1_Y1 EQU	50
PEG1_Y2 EQU	200

PEG2_X1	EQU	PEG1_X1+200
PEG2_X2 EQU	PEG1_X2+200
PEG2_Y1 EQU	PEG1_Y1
PEG2_Y2 EQU	PEG1_Y2

PEG3_X1	EQU	PEG1_X1+400
PEG3_X2 EQU	PEG1_X2+400
PEG3_Y1 EQU	PEG1_Y1
PEG3_Y2 EQU	PEG1_Y2

X1S	DC.W	PEG1_X1,PEG2_X1,PEG3_X1
X2S	DC.W	PEG1_X2,PEG2_X2,PEG3_X2
Y1S	DC.W	PEG1_Y1,PEG2_Y1,PEG3_Y1
Y2S	DC.W	PEG1_Y2,PEG2_Y2,PEG3_Y2

DISC_HEIGHT	EQU	10
D_WIDTH		EQU	10
D1_WIDTH	EQU	10
D2_WIDTH	EQU	20
D3_WIDTH	EQU	30


INIT2:
	LEA	DISCS,A0
	MOVE.B	NUM_DISCS,D0
	SUB.B	#1,D0
ICONT:	MOVE.B	#0,(A0,D0)

	DBF	D0,ICONT
	MOVE.B	#1,LAST
	MOVE.B	#0,NMOVES
	RTS
	
CLR_SCR:
	MOVEM	D0-D4,-(A7)
	
	;SET FILL COLOR
	MOVE.B	#81,D0
	MOVE.L	#$00000000,D1
	TRAP	#15

	;SET SCREEN COORDS
	MOVE.B	#87,D0
	MOVE.W	#0,D1
	MOVE.W	#0,D2
	MOVE.W	#2000,D3
	MOVE.W	#2000,D4
	TRAP	#15		
	
	;RESET CURSOR
	MOVE.B	#11,D0
	MOVE.W	#$0201,D1
	TRAP	#15
	
	MOVEM	(A7)+,D0-D4	
	RTS
	
	
DRAW_PEGS:	
	MOVEM	D0-D4,-(A7)
	;SET FILL COLOR
	MOVE.B	#81,D0
	MOVE.L	#$00303030,D1
	TRAP	#15
	
	;DRAW PEG 1
	MOVE.B	#87,D0
	MOVE.W	#PEG1_X1,D1
	MOVE.W	#PEG1_Y1,D2
	MOVE.W	#PEG1_X2,D3
	MOVE.W	#PEG1_Y2,D4
	TRAP	#15	
	
	;DRAW PEG 2
	MOVE.W	#PEG2_X1,D1
	MOVE.W	#PEG2_Y1,D2
	MOVE.W	#PEG2_X2,D3
	MOVE.W	#PEG2_Y2,D4
	TRAP	#15
	
	;DRAW PEG 3
	MOVE.W	#PEG3_X1,D1
	MOVE.W	#PEG3_Y1,D2
	MOVE.W	#PEG3_X2,D3
	MOVE.W	#PEG3_Y2,D4
	TRAP	#15
	MOVEM	(A7)+,D0-D4	

	RTS


DRAW_DISCS2: MOVEM	D0-D7,-(A7)
	;SET FILL COLOR
	MOVE.B	#81,D0
	MOVE.L	#$00A0A0A0,D1
	TRAP	#15
	
	;CLR PEG-DISC COUNTS
	LEA	PDISC_COUNT,A3
	MOVE.B	#0,(0,A3)
	MOVE.B	#0,(1,A3)
	MOVE.B  #0,(2,A3)
	
	CLR.W	D7
	MOVE.B	NUM_DISCS,D7
	SUB.B	#1,D7
	LEA	DISCS,A0
	
DDLOOP: CLR.W	D6
	MOVE.B 	D7,D6
	ADD.B	#1,D6
	MULU.W	#D_WIDTH,D6
	MOVE.B	(A0,D7),D5
	LSL.B	#1,D5
		
	;CALC X COORDS
	LEA	X1S,A1
	MOVE.W	(A1,D5),D1
	SUB.W	D6,D1
	LEA	X2S,A1
	MOVE.W	(A1,D5),D3
	ADD.W	D6,D3

	;CALC Y COORDS
	LEA	Y2S,A1
	MOVE.W	(A1,D5),D2
	SUB.W	#DISC_HEIGHT,D2	
	MOVE.W	(A1,D5),D4
	;CORRECT HEIGHT
	CLR.W	D6
	LSR.B	#1,D5
	MOVE.B	(A3,D5),D6
	MULU.W	#DISC_HEIGHT,D6
	SUB.W	D6,D2
	SUB.W	D6,D4
	
	ADD.B	#1,(A3,D5)
	
	MOVE.B	#87,D0
	TRAP	#15
	
	DBF	D7,DDLOOP

	MOVEM	(A7)+,D0-D7
	RTS	



MOVE_DISC2:
	MOVEM	D0-D7,-(A7)
	LEA	DISCS,A0
	
	CMP.B	#0,LAST
	BEQ	OTHER2
	
	;MOVE SMALLEST DISC
	MOVE.B	#0,LAST
	ADD.B	#1,(0,A0)
	CMP.B	#3,(0,A0)
	BNE	MD_RET2
	MOVE.B	#0,(0,A0)
	BRA	MD_RET2
	
OTHER2:  ;MOVE NEXT SMALLEST FREE DISC
	MOVE.B	#1,LAST

	MOVE.B	(0,A0),D0 ;GET PEG OF SMALLEST
	MOVE.B	#1,D7
MD2_CONT:
	CMP.B	(A0,D7),D0
	BNE	MD2_FND	
	ADD.B	#1,D7
	BRA MD2_CONT
	
MD2_FND:
	MOVE.B	#3,D2
	SUB.B	(A0,D7),D2
	SUB.B	D0,D2
	MOVE.B	D2,(A0,D7)

MD_RET2:	
	MOVEM	(A7)+,D0-D7
	RTS


START:			; first instruction of program
	MOVE.B	#18,D0
	LEA	GET_DSC,A1
	TRAP	#15
	MOVE.B	D1,NUM_DISCS
	
	LEA	TIME,A1
	TRAP	#15
	DIVU	#10,D1
	MOVE.W	D1,TM_DELAY	
	
	BSR	INIT2
	
LOOP:
	BSR	CLR_SCR
	BSR	DRAW_PEGS
	BSR	DRAW_DISCS2
	;DISPLAY MOVE COUNT
	;SET FILL COLOR
	MOVE.B	#81,D0
	MOVE.L	#$00000000,D1
	TRAP	#15
	MOVE.B	#17,D0
	LEA	NM_MSG,A1
	MOVE.L	NMOVES,D1	
	TRAP	#15
	
	;DELAY 700MS
	MOVE.B	#23,D0
	CLR.L	D1
	MOVE.W	TM_DELAY,D1
	TRAP	#15
	
	BSR	MOVE_DISC2
	ADD.L	#1,NMOVES
	
	;CHEACK TO SEE IF ALL ARE ON SAME PEG
	MOVE.B	NUM_DISCS,D7
	SUB.B	#1,D7
	LEA	DISCS,A0
	MOVE.B	(A0,D7),D0 ;RECORD LOC OF LAST DISC
	SUB.B	#1,D7
CK:	CMP.B	(A0,D7),D0
	BNE	LOOP
	DBF	D7,CK
	
	;DRAW ONE LAST TIME
	BSR	CLR_SCR
	BSR	DRAW_PEGS
	BSR	DRAW_DISCS2	
	
	;DISPLAY MOVE COUNT
	;SET FILL COLOR
	MOVE.B	#81,D0
	MOVE.L	#$00000000,D1
	TRAP	#15
	MOVE.B	#17,D0
	LEA	NM_MSG,A1
	MOVE.L	NMOVES,D1	
	TRAP	#15
	
	
	MOVE.B	#9,D0
	TRAP	#15	; halt simulator

 *Variables and Strings
LAST	DS	1
DISCS	DS	20
NMOVES	DC.L	0
TM_DELAY DC.W	0
PDISC_COUNT DC.B 0,0,0
NM_MSG	DC.B	'Number of moves: ',0
GET_DSC	DC.B	'How many discs do you want: ',0
TIME	DC.B	'Time delay in milliseconds: ',0
NUM_DISCS DC.B	0

	END	START	; last line of source






*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
